Program LexikalisKiertekeles; {az A1. reszfeladat programja}
(*
  Feladat:
          Aritmetikai kifejezs kirtkelse.

  A. Rszletesebben:
  A1. Egy kif sztringben hagyomnyos infix kifejezs van.
      Ezt lexiklis egysgeire bontjuk (lexEgys): lexKif.
      A lexEgys-eket hagyomnyos Text-ben (lexKif) troljuk:
      egy sor - egy lexiklis egysg bontsban.
  A2. Az elbbi lexiklis egysgeket tartalmaz file-bl
      kiindulva ellltjuk a post-fix lengyelformjt: pfKif.
      Ez is egy Text (pfKif), elbbivel azonos konvencival, azaz
      egy sor - egy lexiklis egysg.
  A3. A pfKif file-bl tovbblpve kiszmoljuk a kifejezs
      rtkt.
      Ha voltak a kifejezsben vltozk, akkor e programnak kell
      gondoskodnia az rtkek beolvassrl is.

  B. Mg rszletesebben:
  B1. Megengedett lexiklis egysgek. Azaz, amiket tartalmazhat
      a bemen (kif) sztring:
      B1.1. Szmkonstansok
      B1.2. Szmvltozk (azonostja egy betbl ll szveg)
      B1.3. Elemi aritmetikai mveleti jelek ('+','-','*','/','^')
      B1.4. Nhny valsrtk aritmetikai fggvny ('Sin','Cos',
           'Sqrt','Tg','Pi'...)
  B2. A bemen kifejezssel szemben elvrt specilis felttelek:
      B2.1. Minden lexiklis egysg kztt pontosan egy szkz van.
      B2.2. A fggvnyek argumentumt ktelez bezrjelezni.
      Pl.:
         a * Sin ( b * x + Pi / 2 ) - 5.4321
      B2.3. Kis- s nagybetket nem klnbztetnk meg.
      B2.4. A kifejezs eltt s utn nincsen szkz.
  B3. A lexiklis egysgek megjelense a lexKif Text-ben: rtkpr
      formjban.
        lexEgys --> (mifle + rtke)
      A mifle s hozzrendelt kdja:
      * Szmkonstans: 0
      * Szmvtloz: 1
      * Mvelet (s a zrjelek): 2
      Egy nhny lexiklis egysgre plda:
        ( 0 , '5.4321' )
        ( 1 , 'a' )
        ( 2 , 'Sin' )
      A lexKif file-ra plda:
        ( 1 , 'a' )
        ( 2 , '*' )
        ( 2 , 'Sin' )
        ( 2 , '(' )
        ( 1 , 'b' )
        ( 2 , '*' )
        ( 1 , 'x' )
        ( 2 , '+' )
        ...
        ( 0 , '5.4321' )
  B4. A lexiklis egysgek megjelense a pfKif Text-ben: rtkpr
      formjban.
        lexEgys --> (mifle + rtke)
      A pfKif file-ra plda:
        ( 1 , 'a' )
        ( 1 , 'b' )
        ( 1 , 'x' )
        ( 2 , '*' )
        ( 2 , 'Pi' )
        ( 0 , '2' )
        ( 2 , '/' )
        ( 2 , '+' )
        ( 2 , 'Sin' )
        ( 2 , '*' )
        ...
  C. Az egyes rszfeladatokat (l. A1-A3.) nllan fut programok
     vgzik el. A kapcsolatot file-okon keresztl tartjk.
     (Elkpzelhet, hogy a fent nevestett file-okon tl [lexKif, pfKif]
     tovbbiak is clszerek [pl. a mveleti tblt tartalmaz file,
     ami soronknt felsorolja a leglis opertorokat esetleg precedencijukkal
     egytt; ekppen:
       + 5
       - 5
       * 6
       / 6
       ^ 7
       Pi 10
       Sin 10
       Cos 10
       Tg 10
       Sqrt 10
     )

*)
  Uses Newdelay,Crt,Crt22;

  {$i AltRutin.inc}
  {$i lengyel.inc -- a lengyelforma kiertekeles programjainak kozos dolgai}

  Var   kif:String;  {billentyu input}
        lexKif:Text; {file output: Text-esitett,
                      soregysegre tordelt TLexEgys file}
  Const lexKifFn='lexKif.txt';

  Const tollSzin=Black;
        papirSzin=White;
        link=128;

  Function Beolvasas:String;
    Var i,j:Byte;
        ss,s:String;
  Begin
    UjLap('Lengyelforma -- kifejezs-beolvass',0);
    Write('Krem az aritmetikai kifejezst:');
    Readln(s);
    {nagybetusit:}
    For i:=1 to Length(s) do s[i]:=UpCase(s[i]);

    {a muveleti jelek szokozokkel tagolasa --ha meg nem lenne--:}
    For i:=1 to MaxMuv do
    Begin
      ss:='';
      Repeat
        j:=Pos(Op[i].jel,s);
        If j>0 then
        Begin
          ss:=ss+Copy(s,1,j-1)+' '+Copy(s,j,Length(Op[i].jel))+' ';
          s:=Copy(s,j+Length(Op[i].jel),Length(s)-j-Length(Op[i].jel)+1)
        End;
      Until j=0;
      s:=ss+s
    End;
    {elo- es vegszokozok levagasa:}
    i:=1;
    While (i>0) and (s[i]=' ') do Inc(i);
    Delete(s,1,i-1);
    i:=Length(s);
    While (i>0) and (s[i]=' ') do Dec(i);
    Delete(s,i+1,Length(s)-i);
    {folosleges szokozok elhagyasa:}
    i:=1; {barmi, ami >0}
    While i>0 do
    Begin
      i:=Pos('  ',s); Delete(s,i,1);
    End;

    Beolvasas:=s
  End;

  Procedure FileMegnyitas(fN:String; Var f:Text);
    Var  hiba:Integer;
  Begin
    UjLap('Lengyelforma -- file-megnyits',0);
    Repeat
      {$i-}
      Assign(f,fN); Reset(f);
      hiba:=IOResult;
      If hiba<>0 then
      Begin
        Rewrite(f);
        hiba:=IOResult;
        If hiba<>0 then
        Begin
          TextColor(Red+Blink);
          Writeln('A file nem nyithat meg:');
          Writeln('  Hibs file-nv.');
          TextColor(tollSzin);
          BillreVar
        End
      End
        Else
      Begin
        Rewrite(f);
        TextColor(Red+Blink);
        Writeln('  Ilyen file mr van. A file fellrdik.');
        TextColor(tollSzin);
        BillreVar
      End;
      {$i+}
    Until hiba=0;
  End;

  Function Elemez(le:String):TFajta;
    Var x:Real;
        i,siker:Integer;
  Begin
    Val(le,x,siker);
    If siker<>0 then
    Begin
      i:=1;
      While (i<=MaxMuv) and (Op[i].jel<>le) do Inc(i);
      If i<=MaxMuv then Elemez:=Muv
                   else Elemez:=Valt;
    End
      else
    Begin
      Elemez:=Szam
    End;
  End;

  Procedure Felbont(kif:String; Var lk:Text);
    {Ef: Minden lexiklis egysg kztt pontosan egy szkz van.}
    Var miASzosz:TFajta;
        ig:Byte;
        le:String;
        leO:OLexEgys;
  Begin
    UjLap('Lengyelforma -- kifejezs-felbonts',0);
    ig:=Length(kif);
    While ig>0 do
    Begin
      ig:=Pos(' ',kif);
      If ig>0 then
      Begin
        le:=Copy(kif,1,ig-1);
        kif:=Copy(kif,ig+1,Length(kif)-ig);
        miASzosz:=Elemez(le);
      End
        else
      Begin
        le:=kif;
        kif:='';
        miASzosz:=Elemez(le);
      End;
      leO.Letrehoz(miASzosz,le);
      leO.Writeln(lk);
      leO.Lerombol;
      {ellenorzo kiiras:}
      Writeln(KFajta[miASzosz],' (',SFajta[miASzosz],') ',le);
    End;
  End;

Begin
  UjLap('Lengyelforma',0);
  TextColor(tollSzin); TextBackground(papirSzin);
  kif:=Beolvasas;
  FileMegnyitas(lexKifFn,lexKif);
  Felbont(kif,lexKif);
  Close(lexKif);
  BillreVar
End.